unit UF_CoinRemote;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TF_Main = class(TForm)
    B_Add1    : TButton;
    B_Add2    : TButton;
    B_Add3    : TButton;
    B_Add4    : TButton;
    B_Add5    : TButton;
    B_Add6    : TButton;
    B_Add7    : TButton;
    B_Add8    : TButton;
    B_Add9    : TButton;
    B_Add10   : TButton;
    B_Quit    : TButton;
    P_Status  : TPanel;
    L_Info    : TLabel;
    L_Status  : TLabel;
    BV_Line   : TBevel;
    M_Ex2     : TMemo;
    B_Ins4    : TButton;
    B_Ins5    : TButton;
    B_Ins6    : TButton;
    procedure B_Add1Click(Sender: TObject);
    procedure B_QuitClick(Sender: TObject);
  private
  public
    procedure SendKeyString(Text:String);
    procedure SendKeysToTitle(WindowTitle: String; Text: String);
  end;

var
  F_Main: TF_Main;

implementation

{$R *.DFM}

(* ---------------------------------------------------------------------------------------------- *)
procedure TF_Main.SendKeyString(Text:String);
var i:Integer; Shift:Boolean; vk,ScanCode:Word; ch:Char; c,s:Byte;
const
 vk_keys: Array[0..9] of Byte=(VK_HOME,VK_END,VK_UP,VK_DOWN,VK_LEFT,VK_RIGHT,VK_PRIOR,VK_NEXT,VK_INSERT,VK_DELETE);
 vk_shft: Array[0..2] of Byte=(VK_SHIFT,VK_CONTROL,VK_MENU);
 flags: Array[False..True] of Integer=(KEYEVENTF_KEYUP,0);
begin
 Shift:=False;
 for i:=1 to Length(Text) do begin
  ch := Text[i];
  if ch>=#250 then begin
   s:=Ord(ch)-250;
   Shift:=not Odd(s);
   c:=vk_shft[s shr 1];
   ScanCode:=MapVirtualKey(c,0);
   Keybd_Event(c,Scancode,Flags[shift],0);
  end else begin
   vk:=0;
   if ch>=#240 then c:=vk_keys[Ord(ch)-240]
    else if ch>=#228 then c:=Ord(ch)-116
     else if ch<#110 then c:=Ord(ch)
      else begin
       vk:=VkKeyScan(ch);
       c:=LoByte(vk);
      end;
   ScanCode := MapVirtualKey(c,0);
   if not Shift and (Hi(vk)>0) then Keybd_Event(VK_SHIFT,$2A,0,0);
   Keybd_Event(c,scancode,0,0);
   Keybd_Event(c,scancode,KEYEVENTF_KEYUP,0);
   if not Shift and (Hi(vk)>0) then Keybd_Event(VK_SHIFT,$2A,KEYEVENTF_KEYUP,0);
  end;
 end;
end;

(* ---------------------------------------------------------------------------------------------- *)
procedure TF_Main.SendKeysToTitle(WindowTitle: String; Text: String);
var StrBuf: Array[0..$FF] of Char; Window: hWnd;
begin
 Window:=FindWindow(PChar(0),StrPCopy(StrBuf,WindowTitle));
 If (Window>0) Then Begin
  if IsIconic(Window) then ShowWindow(Window,SW_RESTORE) else BringWindowToTop(Window);
  SendKeyString(Text);
  L_Status.Caption:='Info transmitted!';
 End Else L_Status.Caption:='Jukebox not found!';
end;

(* ---------------------------------------------------------------------------------------------- *)
procedure TF_Main.B_Add1Click(Sender: TObject);
Var CoinCount:Integer;
begin
 CoinCount:=TButton(Sender).Tag;
 SendKeysToTitle('DSD Jukebox (Party-Player)',Chr(227+CoinCount));
end;

(* ---------------------------------------------------------------------------------------------- *)
procedure TF_Main.B_QuitClick(Sender: TObject);
begin
 Close;
end;

(* ---------------------------------------------------------------------------------------------- *)
end.
